program mindbust;

{ V.0.900 15.02.96: Images, Bildschirmaufbau, 1. spielbare Version }
{ V.1.000 16.02.96: Levels, Enderoutine, Key+Maushandle            }

uses crt,dos,intuit,drivers,graph;


const imafile='mindbus0.ima'; levelfile='mindbust.l';
      header=' o    U J A ''s     M i n d b u s t e r            o   V.1.000   o   TP6   o';
      xmax=6; ymax=8; smax=48; ox=-40; oy=-16; dx=48; dy=48; dd=24;
      dx2=54; dy2=54; ox2=300+ox; oy2=-32;
      pal:array[0..15,0..2] of word=(
      (   0,   0,   0 ),(  27,  26,  39 ),(  61,  52,  63 ),(  63,  63,  63 ),
      (   0,  41,  13 ),(  30,  54,  42 ),(  54,  52,   9 ),(  63,  58,  36 ),
      (  63,  23,  23 ),(  63,  33,  33 ),(   7,  48,  48 ),(  15,  63,  63 ),
      (  28,  28,  45 ),(  36,  37,  63 ),(  52,   8,  52 ),(  62,  29,  63 ));

type stein=record
              id,x,y,xx,yy,f1,f2,f3,f4,ri:integer;
              aktiv                      :boolean;
           end;
     feld =array[0..succ(xmax),0..succ(ymax)] of stein;
     patt =array[0..succ(xmax),0..succ(ymax)] of boolean;
     patti=array[0..succ(xmax),0..succ(ymax)] of integer;
     liste=array[0..smax] of integer;

var ok,neu,alt,ende,fertig:boolean;
    ima                   :array[1..48] of Image;
    igad                  :array[1..8] of Gadget;
    sinfo                 :StrInfo;
    itext1,itext2         :array[1..8] of IntuiText;
    ibord1,ibord2         :Border;
    xy1,xy2               :Koords;
    err,l,g,mx,my,oldx,oldy,oldz:integer;
    ch0,ch1               :char;
    temp                  :string;
    chip                  :array[0..smax] of stein;
    f                     :feld;
    level                 :patt;
    belegt1,belegt2       :patti;
    l1                    :liste;

    ch:char;
{ ------------------------------------------------------------------------ }
procedure initgadgets;
var i,j,k:integer;
begin
   itext1[1].itext:='Level:';
   itext1[2].itext:='Lsung';
   itext1[3].itext:=' Neu  ';
   itext1[4].itext:=' Alt  ';
   itext1[5].itext:=' Quit ';
   for i:=1 to 5 do with itext1[i] do begin
      if i=1 then x:=-56 else x:=8;
      y:=2;
      fpen:=3;
      bpen:=2;
      drmode:=jam1;
      p_nexttext:=addr(itext2[i]);
   end;
   itext2:=itext1;
   for i:=1 to 5 do with itext2[i] do begin
      x:=pred(itext1[i].x);
      fpen:=0;
      p_nexttext:=nil;
   end;

   xy1[0]:=-1; xy1[1]:=-1; xy1[2]:=60; xy1[3]:=-1; xy1[4]:=60; xy1[5]:=12;
   xy1[6]:=-1; xy1[7]:=12; xy1[8]:=-1; xy1[9]:=-1;
   xy2[0]:=-2; xy2[1]:=-2; xy2[2]:=61; xy2[3]:=-2; xy2[4]:=61; xy2[5]:=13;
   xy2[6]:=-2; xy2[7]:=13; xy2[8]:=-2; xy2[9]:=-2;

   with ibord1 do begin
      x:=0;
      y:=0;
      fpen:=1;
      bpen:=-1;
      drmode:=jam1;
      ecken:=5;
      p_ecken:=addr(xy1);
      p_nextborder:=addr(ibord2);
   end;
   ibord2:=ibord1;
   with ibord2 do begin
      fpen:=0;
      p_ecken:=addr(xy2);
      p_nextborder:=nil;
   end;

   with sinfo do begin
      x:=8;
      y:=2;
      maxlen:=3;
      fpen:=0;
      bpen:=2;
      buff:=' 0';
      ubuff:='';
  end;


   for i:=1 to 5 do with igad[i] do begin
      id:=i;
      if i=1 then x:=64 else x:=64*i+256;
      y:=466;
      width:=60;
      height:=12;
      bpen:=2;
      hibpen:=bpen;
      p_loborder:=addr(ibord1);
      p_hiborder:=p_loborder;
      p_loimage:=nil;
      p_hiimage:=p_loimage;
      p_lointuitext:=addr(itext1[i]);
      p_hiintuitext:=p_lointuitext;
      if i=1 then gadgettyp:=Strgadget else gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      if i=1 then p_specialinfo:=addr(sinfo) else p_specialinfo:=nil;
      p_nextgadget:=addr(igad[succ(i)]);
   end;
   i:=6;
   with igad[i] do begin
      id:=i;
      x:=ox+dx;
      y:=oy+dy;
      width:=dx*xmax;
      height:=dy*ymax;
      bpen:=-1;
      hibpen:=bpen;
      p_loborder:=nil;
      p_hiborder:=p_loborder;
      p_loimage:=nil;
      p_hiimage:=p_loimage;
      p_lointuitext:=nil;
      p_hiintuitext:=p_lointuitext;
      gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=addr(igad[succ(i)]);
   end;
   i:=7;
   with igad[i] do begin
      id:=i;
      x:=ox2+dx2;
      y:=oy2+dy2;
      width:=dx2*xmax;
      height:=dy2*ymax;
      bpen:=-1;
      hibpen:=bpen;
      p_loborder:=nil;
      p_hiborder:=p_loborder;
      p_loimage:=nil;
      p_hiimage:=p_loimage;
      p_lointuitext:=nil;
      p_hiintuitext:=p_lointuitext;
      gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=nil;
   end;
   RefreshGadgets(addr(igad[1]));
end;

{ ------------------------------------------------------------------------ }

procedure getstring(g:integer);
{ Eingaberoutine fuer Stringgadget }
var i:integer;
    csr:string;
    ch:char;
begin
with igad[g] do begin
   p_specialinfo^.ubuff:=p_specialinfo^.buff;
   p_specialinfo^.buff:='';
   i:=0;
   csr:='_';
   while keypressed do ch:=readkey;
   ch:='+';
   rectfill(x,y,x+pred(width),y+pred(height),p_specialinfo^.bpen);
   setcolor(p_specialinfo^.fpen);
   outtextxy(x+p_specialinfo^.x,y+p_specialinfo^.y,p_specialinfo^.buff+csr);
   while (i<p_specialinfo^.maxlen) and (ch<>#13) do
   if keypressed then begin
      ch:=readkey;
      if (ch>#31) and (ch<#255) then begin
         p_specialinfo^.buff:=p_specialinfo^.buff+ch;
         inc(i);
      end;
      if ch=#8 then if i>0 then begin { backspace }
         delete(p_specialinfo^.buff,i,1);
         dec(i);
      end;
      if ch=#27 then begin
         p_specialinfo^.buff:=p_specialinfo^.ubuff;
         i:=0;
      end;
      rectfill(x,y,x+pred(width),y+pred(height),p_specialinfo^.bpen);
      setcolor(p_specialinfo^.fpen);
      outtextxy(x+p_specialinfo^.x,y+p_specialinfo^.y,p_specialinfo^.buff+csr);
   end; { keypressed }
end;
end;

{ ------------------------------------------------------------------------ }


{ ------------------------------------------------------------------------ }

procedure getimages;
var i,j,k,anz:integer;
    fh   :file;
begin
{ Urbild einlesen: }
assign(fh,imafile);
reset(fh,1);
BlockRead(fh,ima[1],sizeof(Image),anz);
with ima[1] do begin
   anz:=imagesize(1,1,width,height);
   GetMem(p_data,anz);
   BlockRead(fh,p_data^,anz,anz);
   putimage(0,0,p_data^,normalput);
   FreeMem(p_data,anz);
end;
close(fh);

{ Images erzeugen: }
k:=0;
for j:=0 to 2 do for i:=0 to 2 do begin
   inc(k);
   with ima[k] do begin
      x:=0; y:=0; width:=dx; height:=dd;
      anz:=Imagesize(1,1,width,height);
      getmem(p_data,anz);
      getimage(2*i*dx+dd,j*dy,2*i*dx+dd+pred(width),j*dy+pred(height),p_data^);
      p_nextimage:=nil;
   end;
   inc(k);
   with ima[k] do begin
      x:=0; y:=0; width:=dd; height:=dy;
      anz:=Imagesize(1,1,width,height);
      getmem(p_data,anz);
      getimage(2*i*dx,j*dy,2*i*dx+pred(width),j*dy+pred(height),p_data^);
      p_nextimage:=nil;
   end;
   inc(k);
   with ima[k] do begin
      x:=0; y:=0; width:=dx; height:=dd;
      anz:=Imagesize(1,1,width,height);
      getmem(p_data,anz);
      getimage(2*i*dx+dd,j*dy+dd,2*i*dx+dd+pred(width),j*dy+dd+pred(height),p_data^);
      p_nextimage:=nil;
   end;
   inc(k);
   with ima[k] do begin
      x:=0; y:=0; width:=dd; height:=dy;
      anz:=Imagesize(1,1,width,height);
      getmem(p_data,anz);
      getimage(2*i*dx+3*dd,j*dy,2*i*dx+pred(width)+3*dd,j*dy+pred(height),p_data^);
      p_nextimage:=nil;
   end;
end;

j:=3;
for i:=0 to 1 do begin
   inc(k);
   with ima[k] do begin
      x:=0; y:=0; width:=dx; height:=dd;
      anz:=Imagesize(1,1,width,height);
      getmem(p_data,anz);
      getimage(2*i*dx+dd,j*dy,2*i*dx+dd+pred(width),j*dy+pred(height),p_data^);
      p_nextimage:=nil;
   end;
   inc(k);
   with ima[k] do begin
      x:=0; y:=0; width:=dd; height:=dy;
      anz:=Imagesize(1,1,width,height);
      getmem(p_data,anz);
      getimage(2*i*dx,j*dy,2*i*dx+pred(width),j*dy+pred(height),p_data^);
      p_nextimage:=nil;
   end;
   inc(k);
   with ima[k] do begin
      x:=0; y:=0; width:=dx; height:=dd;
      anz:=Imagesize(1,1,width,height);
      getmem(p_data,anz);
      getimage(2*i*dx+dd,j*dy+dd,2*i*dx+dd+pred(width),j*dy+dd+pred(height),p_data^);
      p_nextimage:=nil;
   end;
   inc(k);
   with ima[k] do begin
      x:=0; y:=0; width:=dd; height:=dy;
      anz:=Imagesize(1,1,width,height);
      getmem(p_data,anz);
      getimage(2*i*dx+3*dd,j*dy,2*i*dx+pred(width)+3*dd,j*dy+pred(height),p_data^);
      p_nextimage:=nil;
   end;
end;

inc(k);
with ima[k] do begin
   x:=0; y:=0; width:=dx; height:=dy;
   anz:=Imagesize(1,1,width,height);
   getmem(p_data,anz);
   getimage(4*dx,3*dy,4*dx+pred(width),3*dy+pred(height),p_data^);
   p_nextimage:=nil;
end;
end;

{ ------------------------------------------------------------------------ }

procedure bildschirm;
var i,j,k:integer;
begin
rectfill(0,0,639,479,1);
rectfill(0,0,639,15,0);
rectfill(0,464,639,479,1);
rectfill(0,1,639,14,0);
rectfill(0,465,639,478,0);
rectfill(0,2,639,13,2);
rectfill(0,466,639,477,2);
rectfill(300,16,307,463,0);
rectfill(302,16,305,463,2);
setcolor(3); outtextxy(16,4,header);
setcolor(0); outtextxy(15,4,header);
end;

{ ------------------------------------------------------------------------ }

procedure setcolors;
var i:integer;
begin
   for i:=0 to 15 do setrgbpalette(i,pal[i,0],pal[i,1],pal[i,2]);
end;

procedure darken;
var i:integer;
begin
   for i:=0 to 15 do setpalette(i,0);
end;

procedure lighten;
var i:integer;
begin
   for i:=0 to 15 do setpalette(i,i);
end;

{ ------------------------------------------------------------------------ }
procedure levelladen(var l:integer; var level:patt);
var fh:text;
    temp,t2:string;
    i,j,k:integer;
begin
   for i:=0 to succ(xmax) do for j:=0 to succ(ymax) do level[i,j]:=false;
   str(l:2,temp);
   for i:=1 to length(temp) do if temp[i]=' ' then temp[i]:='0';
   temp:=levelfile+temp;
{$i-}
   assign(fh,temp);
   reset(fh);
   k:=ioresult;
   if k=0 then for i:=1 to ymax do begin
      readln(fh,t2);
      for j:=1 to length(t2) do  level[j,i]:=t2[j]='#';
   end else begin
      for i:=3 to 5 do for j:=3 to 5 do level[i,j]:=true;
      l:=0;
   end;
   close(fh);
{$i+}
   k:=ioresult;
end;
{ ------------------------------------------------------------------------ }

procedure initfeld;
{ initialisiert das Feld, die Chips, die 1.Liste }
var i,j,k:integer;
begin
   for i:=0 to succ(xmax) do for j:=0 to succ(ymax) do with f[i,j] do begin
      f1:=0;
      f2:=0;
      ri:=0;
      x:=i;
      y:=j;
      aktiv:=false;
      belegt1[i,j]:=-1;
      belegt2[i,j]:=-1;
   end;
   for i:=1 to xmax do for j:=1 to ymax do with f[i,j] do begin
      f1:=succ(random(1000) mod 10);
      f2:=succ(random(1000) mod 10);
   end;
   for i:=1 to xmax do for j:=1 to ymax do with f[i,j] do begin
      if j=ymax then f3:=succ(random(1000) mod 10)
                else f3:=f[i,succ(j)].f1;
      if i=xmax then f4:=succ(random(1000) mod 10)
                else f4:=f[succ(i),j].f2;
   end;
   k:=0;
   for i:=1 to xmax do for j:=1 to ymax do if level[i,j] then begin
      inc(k);
      f[i,j].aktiv:=true;
      chip[k]:=f[i,j];
      l1[k]:=k;
   end;
   l1[0]:=k;
end;

{ ------------------------------------------------------------------------ }

procedure zeichnechip(x,y,f,id:integer);
var k:integer;
begin
   if f=0 then begin
      k:=4*pred(chip[id].f1)+1;
      PutImage(x*dx+ox,y*dy+oy,ima[41].p_data^,andput);
      PutImage(x*dx+ox,y*dy+oy,ima[k].p_data^,orput);
      k:=4*pred(chip[id].f2)+2;
      PutImage(x*dx+ox,y*dy+oy,ima[42].p_data^,andput);
      PutImage(x*dx+ox,y*dy+oy,ima[k].p_data^,orput);
      k:=4*pred(chip[id].f3)+3;
      PutImage(x*dx+ox,y*dy+oy+dd,ima[43].p_data^,andput);
      PutImage(x*dx+ox,y*dy+oy+dd,ima[k].p_data^,orput);
      k:=4*pred(chip[id].f4)+4;
      PutImage(x*dx+ox+dd,y*dy+oy,ima[44].p_data^,andput);
      PutImage(x*dx+ox+dd,y*dy+oy,ima[k].p_data^,orput);
   end else begin
      k:=4*pred(chip[id].f1)+1;
      PutImage(x*dx2+ox2,y*dy2+oy2,ima[41].p_data^,andput);
      PutImage(x*dx2+ox2,y*dy2+oy2,ima[k].p_data^,orput);
      k:=4*pred(chip[id].f2)+2;
      PutImage(x*dx2+ox2,y*dy2+oy2,ima[42].p_data^,andput);
      PutImage(x*dx2+ox2,y*dy2+oy2,ima[k].p_data^,orput);
      k:=4*pred(chip[id].f3)+3;
      PutImage(x*dx2+ox2,y*dy2+oy2+dd,ima[43].p_data^,andput);
      PutImage(x*dx2+ox2,y*dy2+oy2+dd,ima[k].p_data^,orput);
      k:=4*pred(chip[id].f4)+4;
      PutImage(x*dx2+ox2+dd,y*dy2+oy2,ima[44].p_data^,andput);
      PutImage(x*dx2+ox2+dd,y*dy2+oy2,ima[k].p_data^,orput);
   end;
end;

{ ------------------------------------------------------------------------ }

procedure drehen(i:integer);
var k:integer;
begin
   with chip[i] do begin
      k:=f1;
      f1:=f2;
      f2:=f3;
      f3:=f4;
      f4:=k;
   end;
end;

{ ------------------------------------------------------------------------ }

procedure mischen;
var i,j,k:integer;
begin
   randomize;
   for i:=1 to l1[0] do with chip[i] do begin
    {  ri:=random(1000) mod 4;
      if ri>0 then for k:=1 to ri do drehen(chip[i]); }
      k:=succ(random(1000) mod l1[0]);
      j:=l1[i];
      l1[i]:=l1[k];
      l1[k]:=j;
   end;
end;

{ ------------------------------------------------------------------------ }

procedure markieren(x,y:integer; flag:boolean);
var c1,c2:integer;
begin
if flag then begin c1:=15; c2:=11 end else begin c1:=1; c2:=1 end;
setcolor(c1);
line(x*dx2+ox2-1,y*dy2+oy2-1,x*dx2+ox2+dx,y*dy2+oy2-1);
line(x*dx2+ox2-1,y*dy2+oy2+dy,x*dx2+ox2+dx,y*dy2+oy2+dy);
line(x*dx2+ox2-1,y*dy2+oy2,x*dx2+ox2-1,y*dy2+oy2+dy);
line(x*dx2+ox2+dx,y*dy2+oy2,x*dx2+ox2+dx,y*dy2+oy2+dy);
setcolor(c2);
line(x*dx2+ox2-2,y*dy2+oy2-2,x*dx2+ox2+dx+1,y*dy2+oy2-2);
line(x*dx2+ox2-2,y*dy2+oy2+dy+1,x*dx2+ox2+dx+1,y*dy2+oy2+dy+1);
line(x*dx2+ox2-2,y*dy2+oy2-1,x*dx2+ox2-2,y*dy2+oy2+dy+1);
line(x*dx2+ox2+dx+1,y*dy2+oy2-1,x*dx2+ox2+dx+1,y*dy2+oy2+dy+1);
end;

{ ------------------------------------------------------------------------ }

procedure loeschen(x,y,k:integer);
begin
   if k=0 then Drawimage(x*dx+ox,y*dy+oy,addr(ima[45]))
          else Drawimage(x*dx2+ox2,y*dy2+oy2,addr(ima[45]))
end;



procedure messi(temp:string);
begin
   rectfill(144,468,360,477,2);
   setcolor(3);
   outtextxy(145,468,temp);
   setcolor(0);
   outtextxy(144,468,temp);
end;

{ ------------------------------------------------------------------------ }

procedure initgame(var l:integer; misch:boolean);
var i,j:integer;
begin
if misch then begin
   darken;
   rectfill(ox+dx,oy+dy,ox+xmax*dx+pred(dx),oy+ymax*dy+pred(dy),1);
   rectfill(ox2+dx2,oy2+dy2,ox2+xmax*dx2+pred(dx2),oy2+ymax*dy2+pred(dy2),1);
   levelladen(l,level);
   initfeld;
   mischen;
end;
for i:=1 to xmax do for j:=1 to ymax do if level[i,j] then begin
   Drawimage(i*dx+ox,j*dy+oy,addr(ima[45]));
   belegt1[i,j]:=-1;
end;
for i:=1 to l1[0] do with chip[l1[i]] do begin
   xx:=succ(pred(i) mod 6);
   yy:=succ(pred(i) div 6);
   if i>l1[0] then belegt2[xx,yy]:=-1 else begin
      zeichnechip(xx,yy,1,l1[i]);
      belegt2[xx,yy]:=l1[i];
   end;
end;
oldx:=-1;
messi('auf geht''s    ');
lighten;
end;

{ ------------------------------------------------------------------------ }

procedure aufloesung;
var k:integer;
begin
   if oldx>-1 then markieren(oldx,oldy,false);
   initgame(l,false);
   for k:=1 to l1[0] do with chip[k] do begin
      while ri>0 do drehen(k);
      zeichnechip(xx,yy,1,k);
      markieren(xx,yy,true);
      delay(1500);
      markieren(xx,yy,false);
      loeschen(xx,yy,1);
      zeichnechip(x,y,0,k);
      delay(500);
   end;
end;

{ ---------------------------------------------------------------- }

procedure selektieren(var oldx,oldy,oldz,mx,my:integer);
var x1,y1:integer;
begin
   x1:=(mx-ox2) div dx2;
   y1:=(my-oy2) div dy2;
   if belegt2[x1,y1]>-1 then begin
      if oldx>0 then markieren(oldx,oldy,false);
      oldx:=x1;
      oldy:=y1;
      oldz:=belegt2[oldx,oldy];
      markieren(oldx,oldy,true);
   end;
end;

{ ------------------------------------------------------------------------ }

function regeln(oldx,oldy,oldz:integer):boolean;
var reg:boolean;
begin
reg:=true;
if belegt1[oldx,pred(oldy)]>-1 then reg:=reg and (chip[oldz].f1=chip[belegt1[oldx,pred(oldy)]].f3);
if belegt1[oldx,succ(oldy)]>-1 then reg:=reg and (chip[oldz].f3=chip[belegt1[oldx,succ(oldy)]].f1);
if belegt1[pred(oldx),oldy]>-1 then reg:=reg and (chip[oldz].f2=chip[belegt1[pred(oldx),oldy]].f4);
if belegt1[succ(oldx),oldy]>-1 then reg:=reg and (chip[oldz].f4=chip[belegt1[succ(oldx),oldy]].f2);
regeln:=reg;
end;

{ ------------------------------------------------------------------------ }

procedure setzen(var oldx,oldy,oldz,mx,my:integer);
var x1,y1:integer;
begin
   x1:=(mx-ox) div dx;
   y1:=(my-oy) div dy;
   if (belegt1[x1,y1]<0) then begin
      if level[x1,y1] then if (oldx>0) then if regeln(x1,y1,oldz) then begin
         belegt1[x1,y1]:=oldz;
         belegt2[oldx,oldy]:=-1;
         markieren(oldx,oldy,false);
         loeschen(oldx,oldy,1);
         zeichnechip(x1,y1,0,belegt1[x1,y1]);
         oldx:=-1;
      end;
   end else begin                   { loeschen }
      markieren(oldx,oldy,false);
      oldz:=belegt1[x1,y1];
      oldx:=chip[oldz].xx;
      oldy:=chip[oldz].yy;
      belegt2[oldx,oldy]:=oldz;
      belegt1[x1,y1]:=-1;
      loeschen(x1,y1,0);
      zeichnechip(oldx,oldy,1,oldz);
      markieren(oldx,oldy,true);
   end;
end;

function checkende:boolean;
var i,j:integer;
    fertig:boolean;
begin
fertig:=true;
for i:=1 to xmax do for j:=1 to ymax do
if level[i,j] then if belegt1[i,j]<0 then fertig:=false;
checkende:=fertig;
end;




{ ------------------------------------------------------------------------ }


begin
initscreen(ok);
if ok then begin
   darken;
   setcolors;
   lighten;
   getimages;
   bildschirm;
   initgadgets;
   l:=0;
   initgame(l,true);
   lighten;
   ende:=false;
   oldx:=0;
   oldy:=0;
   while not ende do begin
      showmouse;
      repeat
         getgadget(addr(igad[1]),g,mx,my);
         if keypressed then begin
            ch0:=readkey;
               case ch0 of
               #27,'Q','q': g:=5;
               'A','a':     g:=4;
               'N','n':     g:=3;
               'L','l':     g:=2;
               '+':         begin
                               inc(l);
                               g:=3;
                            end;
               end;
         end;
      until (g>0);
      hidemouse;

      case g of
      1: begin
            getstring(g);
            val(igad[g].p_specialinfo^.buff,l,err);
            str(l:2,igad[g].p_specialinfo^.buff);
            initgame(l,true);
            str(l:2,igad[g].p_specialinfo^.buff);
            DrawGadget(addr(igad[g]));
         end;
      2: aufloesung;
      3: begin
            initgame(l,true);
            str(l:2,igad[1].p_specialinfo^.buff);
            DrawGadget(addr(igad[1]));
         end;
      4: initgame(l,false);
      5: ende:=true;
      6: begin
            setzen(oldx,oldy,oldz,mx,my);
            if checkende then begin
               messi('Level geschafft!');
               sound(50);
               delay(100);
               nosound;
            end;
         end;
      7: selektieren(oldx,oldy,oldz,mx,my);
      end;
   end;

end;
textmode(3);
end.
